import { IQuat } from '../types.ts';
import { ManagedFloat64Array } from './memory.ts';
import { Vec3 } from './vec.ts';
/** A quaternion. */
export declare class Quat extends ManagedFloat64Array<4> implements IQuat {
    /** Return an identity Quat. */
    static identity(): Quat;
    /** Return a Quat from unit vectors. */
    static fromUnitVecs(from: Vec3, to: Vec3): Quat;
    /** Return a Quat from axis and angle */
    static fromAxisAngle(axis: Vec3, angle: number): Quat;
    /** Return a Quat from rotation around x-axis. */
    static fromAngleX(angle: number): Quat;
    /** Return a Quat from rotation around y-axis. */
    static fromAngleY(angle: number): Quat;
    /** Return a Quat from rotation around z-axis. */
    static fromAngleZ(angle: number): Quat;
    private constructor();
    get length(): 4;
    mul(rhs: Quat): this;
    rotate(v: Vec3): Vec3;
    dot(rhs: Quat): number;
    lerp(rhs: Quat, t: number): this;
    slerp(rhs: Quat, t: number): this;
    normalize(): boolean;
    invert(): boolean;
}
//# sourceMappingURL=quat.d.ts.map